/**
 * =============================================================================
 * ImDawe plugin
 * www.neogames.eu Plugin / Mod request section for plugin request
 * SourceMod (C)2004-2007 AlliedModders LLC.  All rights reserved.
 * =============================================================================
 */
#pragma semicolon 1
#include <sourcemod>
#include <basestock>
#include <sdktools>

// DEFINES
#define VERSION "1.0"

new beamColorT[4] = {255, 0, 0, 255};
new beamColorCT[4] = {0, 0, 255, 255};
new beamColorN[4 ]= {255, 255, 0, 255};
new beamColorM[4]={0, 255, 0, 255};

new g_CurrentZoneTeam[MAXPLAYERS+1];
new g_CurrentZoneVis[MAXPLAYERS+1];
// VARIABLES
new Handle:g_Zones=INVALID_HANDLE;
new g_Editing[MAXPLAYERS+1]={0,...};
new Float:g_Positions[MAXPLAYERS+1][2][3];
new g_ClientSelectedZone[MAXPLAYERS+1]={-1,...};
new g_ClientsStandInBoxCount[MAXPLAYERS+1];
new Handle:g_Hostages=INVALID_HANDLE;
new bool:BombDroped=false;
new Float:BombPos[3];
new bool:g_HurtEnabled=false;
new Handle:tHurtBoxEnabler=INVALID_HANDLE;
new g_BeamSprite;
new g_HaloSprite;
new PlayerHealths[MAXPLAYERS+1]={-1,...};

// CONVARS
//g_eCvars[cvHurtBoxRsDelay][xCache]
new cvHurtBoxRsDelay;
new cvHurtBoxEntDelay;
//new cvHurtBoxDmg;
new cvHurtBoxEnemyExtDelay;

// INCLUDES
#include "scamp/menus.sp"
#include "scamp/beambox.sp"
// PLUGIN INFO
public Plugin:myinfo =
{
	name = "",
	author = "ImDawe",
	description = "",
	version = VERSION,
	url = "http://www.neogames.eu/"
};

public OnPluginStart()
{
	g_Zones = CreateArray(256);
	g_Hostages = CreateArray(256);
	RegAdminCmd("sm_campzones", Command_CampZones, ADMFLAG_ROOT);
	cvHurtBoxRsDelay = RegisterConVar("sm_hurtbox_start_delay", "5.0", "Time before players must leave the Hurt Box (Round Start)", TYPE_FLOAT);
	cvHurtBoxEntDelay = RegisterConVar("sm_hurtbox_enter_delay", "3.0", "Time before players must leave the Hurt Box (Step In/Out)", TYPE_FLOAT);
	//cvHurtBoxDmg = RegisterConVar("sm_hurtbox_damage", "5", "Damage in percentages / second if a player stay in the hurtbox", TYPE_INT);
	cvHurtBoxEnemyExtDelay = RegisterConVar("sm_hurtbox_enemy_extradelay", "3.0", "Time before players must leave the Hurt Box (Enemy Inside)", TYPE_FLOAT);
	HookEvent("round_start", OnRoundStart);
	HookEvent("player_hurt", OnPlayerHurt);
	HookEvent("bomb_dropped", OnBombDrop);
	HookEvent("bomb_pickup", OnBombPickUp);
	HookEvent("hostage_killed", RemoveHostage);
	HookEvent("hostage_rescued", RemoveHostage);
	CreateTimer(1.0, BeamBoxAll, INVALID_HANDLE, TIMER_REPEAT);
	ReadZones();
}

public Action:OnBombPickUp(Handle:event, const String:name[], bool:dontBroadcast)
{
	BombDroped=false;
	//PrintToChatAll("[debug] bomb picked up");
}

public Action:OnBombDrop(Handle:event, const String:name[], bool:dontBroadcast)
{
	BombDroped=true;
	GetClientAbsOrigin(GetClientOfUserId(GetEventInt(event, "userid")), BombPos);
	BombPos[2]=FloatAdd(BombPos[2], 30.0);
}

public Action:RemoveHostage(Handle:event, const String:name[], bool:dontBroadcast)
{
	RemoveFromArray(g_Hostages, FindValueInArray(g_Hostages, GetEventInt(event, "hostage")));
}

public Action:OnPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new size = GetArraySize(g_Zones);
	new Float:posA[3], Float:posB[3], Team;
	for(new i=0;i<size;++i)
	{
		new Handle:trie = GetArrayCell(g_Zones, i);
		GetTrieArray(trie, "corda", posA, sizeof(posA));
		GetTrieArray(trie, "cordb", posB, sizeof(posB));
		GetTrieValue(trie, "team", Team);
		//PrintToChat(p, "%d", IsbetweenRect(NULL_VECTOR, posA, posB, p));
		if(IsbetweenRect(NULL_VECTOR, posA, posB, victim) && !IsbetweenRect(NULL_VECTOR, posA, posB, attacker) && (GetClientTeam(victim)==Team || Team==1))
		{
			g_ClientsStandInBoxCount[victim]=0;
		}
	}
	
}

public Action:OnRoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	BombDroped=false;
	PrintToChatAll("[Anti Spawn Camp] In [%d Seconds] you will start to take damage until you leave Spawn.", RoundToZero(g_eCvars[cvHurtBoxRsDelay][aCache]));
	LoopIngamePlayers(i)
	{
		g_ClientsStandInBoxCount[i]=0;
	}
	if(tHurtBoxEnabler!=INVALID_HANDLE)
	{
		KillTimer(tHurtBoxEnabler);
		tHurtBoxEnabler=INVALID_HANDLE;
	}
	g_HurtEnabled=false;
	tHurtBoxEnabler=CreateTimer(Float:g_eCvars[cvHurtBoxRsDelay][aCache], HurtBoxEnabler);
	ClearArray(g_Hostages);
	new ent = -1;
	while ((ent = FindEntityByClassname(ent, "hostage_entity")) != -1)
	{
		PushArrayCell(g_Hostages, ent);
	}
}

public Action:HurtBoxEnabler(Handle:Timer, any:data)
{
	PrintToChatAll("[Anti Spawn Camp] Leave the spawn now!");
	g_HurtEnabled=true;
	tHurtBoxEnabler=INVALID_HANDLE;
	return Plugin_Stop;
}
public OnMapStart()
{
	PrecacheSound("player/damage1.wav");
	PrecacheSound("player/damage2.wav");
	PrecacheSound("player/damage3.wav");
	g_BeamSprite = PrecacheModel("materials/sprites/laser.vmt");
	g_HaloSprite = PrecacheModel("materials/sprites/halo01.vmt");
	ReadZones();
}

public OnMapEnd()
{
	SaveZones(0);
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	BeamBox_OnPlayerRunCmd(client);
}

public Action:Command_CampZones(client, args)
{
	ZoneMenu(client);
}

public getZoneTeamColor(team, color[4])
{
	switch(team)
	{
		case 1:
		{
			color=beamColorM;
		}
		case 2:
		{
			color=beamColorT;
		}
		case 3:
		{
			color=beamColorCT;
		}
		default:
		{
			color=beamColorN;
		}
	}
	// Get zone team -> get zone color
}

public ReadZones()
{
	ClearArray(g_Zones);
	new String:Path[512];
	BuildPath(Path_SM, Path, sizeof(Path), "configs/zones");
	if(!DirExists(Path))
		CreateDirectory(Path, 0777); 

	new String:map[64];
	GetCurrentMap(map, sizeof(map));
	BuildPath(Path_SM, Path, sizeof(Path), "configs/zones/%s.zones.txt", map);
	if(!FileExists(Path))
	{	
		new Handle:file = OpenFile(Path, "w");
		CloseHandle(file);
		new Handle:kv = CreateKeyValues("Zones");
		KeyValuesToFile(kv, Path);
	}
	
	
	new Handle:kv = CreateKeyValues("Zones");
	FileToKeyValues(kv, Path);
	if (!KvGotoFirstSubKey(kv))
	{
		PrintToServer("[ERROR] Config file is corrupted: %s", Path);
		return;
	}
	decl Float:pos1[3], Float:pos2[3];
	do
	{
		KvGetVector(kv, "cordinate_a", pos1);
		KvGetVector(kv, "cordinate_b", pos2);
		new Handle:trie = CreateTrie();
		SetTrieArray(trie, "corda", pos1, 3);
		SetTrieArray(trie, "cordb", pos2, 3);
		SetTrieValue(trie, "team", KvGetNum(kv, "team", 0));
		SetTrieValue(trie, "vis", KvGetNum(kv, "vis", 0));
		PushArrayCell(g_Zones, trie);
	}while(KvGotoNextKey(kv));
	CloseHandle(kv);
}

public SaveZones(client)
{
	new String:Path[512];
	new String:map[64];
	GetCurrentMap(map, sizeof(map));
	BuildPath(Path_SM, Path, sizeof(Path), "configs/zones/%s.zones.txt", map);
	new Handle:file = OpenFile(Path, "w+");
	CloseHandle(file);
	new Float:pos1[3], Float:pos2[3], String:SectName[64], Team, Vis;
	new size=GetArraySize(g_Zones);
	new Handle:kv = CreateKeyValues("Zones");
	for(new i=0;i<size;++i)
	{
		IntToString(i, SectName, sizeof(SectName));
		
		new Handle:trie = GetArrayCell(g_Zones, i);
		GetTrieArray(trie, "corda", pos1, sizeof(pos1));
		GetTrieArray(trie, "cordb", pos2, sizeof(pos2));
		GetTrieValue(trie, "team", Team);
		GetTrieValue(trie, "vis", Vis);
		
		KvJumpToKey(kv, SectName, true);
		KvSetVector(kv, "cordinate_a", pos1);
		KvSetVector(kv, "cordinate_b", pos2);
		KvSetNum(kv, "vis", Vis);
		KvSetNum(kv, "team", Team);
		KvGoBack(kv);
	}
	KeyValuesToFile(kv, Path);
	CloseHandle(kv);
	if(client!=0)
		PrintToChat(client, "All zones are saved in file.");
}